Index: trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90	(revision 1897)
@@ -36,9 +36,5 @@
 !! summary: Dataset module definition file
 !! author: J. Burgalat
-!! date: 2014
-
-#if HAVE_CONFIG_H
-#include "config.h"
-#endif
+!! date: 2014,2017
 
 MODULE DATASETS 
@@ -65,21 +61,12 @@
   !! Note that for ASCII file, data must be ordered so first dimensions vary first. Same requirement 
   !! is needed for NetCDF file but in most cases, it is implicitly done (if dimensions are ordered).
-  USE LINT_PREC
-#if HAVE_NC_FTN
   USE NETCDF
-#endif
   IMPLICIT NONE
 
   PRIVATE 
 
-  PUBLIC :: read_dset, clear_dset, is_in, debug
+  PUBLIC :: read_dset, write_dset, clear_dset, is_in, has_data, debug
 
   LOGICAL :: debug = .false.  !! A control flag to enable verbose mode
-
-#if HAVE_NC_FTN
-  LOGICAL, PUBLIC, PARAMETER ::nc_supported = .true. !! NetCDF input files are supported
-#else
-  LOGICAL, PUBLIC, PARAMETER ::nc_supported = .false. !! NetCDF input files are not supported
-#endif
 
   !> Initialize a data set from either an ASCII or a NetCDF file
@@ -91,11 +78,14 @@
   !! Netcdf reader interface is available only if the library has been compiled with NetCDF support.
   INTERFACE read_dset 
-#if HAVE_NC_FTN
     MODULE PROCEDURE ncdf_rd_1d,ncdf_rd_2d,ncdf_rd_3d,ncdf_rd_4d,ncdf_rd_5d
 #if HAVE_NC4_FTN
     MODULE PROCEDURE ncdf4_rd_1d,ncdf4_rd_2d,ncdf4_rd_3d,ncdf4_rd_4d,ncdf4_rd_5d
 #endif
-#endif
     MODULE PROCEDURE ascii_rd_1d,ascii_rd_2d,ascii_rd_3d,ascii_rd_4d,ascii_rd_5d
+  END INTERFACE
+
+  !> Write a dataset in a netcdf (classic) file.
+  INTERFACE write_dset 
+    MODULE PROCEDURE nc_wr_1d,nc_wr_2d,nc_wr_3d,nc_wr_4d,nc_wr_5d
   END INTERFACE
 
@@ -111,5 +101,4 @@
 
   !> Private interface to netcdf informations getters
-#if HAVE_NC_FTN
   INTERFACE get_nc_info
     MODULE PROCEDURE get_nc3_info
@@ -118,44 +107,68 @@
 #endif
   END INTERFACE
-#endif
+
+  INTERFACE has_data
+    MODULE PROCEDURE has_d_1d,has_d_2d,has_d_3d,has_d_4d,has_d_5d
+  END INTERFACE
+
 
   TYPE, PUBLIC :: DSET1D
     !! A 1D data set
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE :: x    !! X coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE :: data !! Tabulated function's value at each coordinate
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: x              !! X coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: data           !! Tabulated function's value at each coordinate
+    CHARACTER(len=NF90_MAX_NAME)            :: xname = "X"    !! Name of the X coordinate
+    CHARACTER(len=NF90_MAX_NAME)            :: dname = "data" !! Name of the data block
   END TYPE DSET1D
 
   TYPE, PUBLIC :: DSET2D
     !! A 2D data set
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE   :: x    !! X coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE   :: y    !! Y coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:,:), ALLOCATABLE :: data !! Tabulated function's value at each coordinate
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE   :: x              !! X coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE   :: y              !! Y coordinate tabulated values
+    REAL(kind=8), DIMENSION(:,:), ALLOCATABLE :: data           !! Tabulated function's value at each coordinate
+    CHARACTER(len=NF90_MAX_NAME)              :: xname = "X"    !! Name of the X coordinate
+    CHARACTER(len=NF90_MAX_NAME)              :: yname = "Y"    !! Name of the Y coordinate
+    CHARACTER(len=NF90_MAX_NAME)              :: dname = "data" !! Name of the data block
   END TYPE DSET2D
 
   TYPE, PUBLIC :: DSET3D
     !! A 3D data set
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE     :: x    !! X coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE     :: y    !! Y coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE     :: z    !! Z coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:,:,:), ALLOCATABLE :: data !! Tabulated function's value at each coordinate
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE     :: x              !! X coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE     :: y              !! Y coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE     :: z              !! Z coordinate tabulated values
+    REAL(kind=8), DIMENSION(:,:,:), ALLOCATABLE :: data           !! Tabulated function's value at each coordinate
+    CHARACTER(len=NF90_MAX_NAME)                :: xname = "X"    !! Name of the X coordinate
+    CHARACTER(len=NF90_MAX_NAME)                :: yname = "Y"    !! Name of the Y coordinate
+    CHARACTER(len=NF90_MAX_NAME)                :: zname = "Z"    !! Name of the Z coordinate
+    CHARACTER(len=NF90_MAX_NAME)                :: dname = "data" !! Name of the data block
   END TYPE DSET3D
 
   TYPE, PUBLIC :: DSET4D
     !! A 4D data set
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE       :: x    !! X coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE       :: y    !! Y coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE       :: z    !! Z coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE       :: t    !! T coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:,:,:,:), ALLOCATABLE :: data !! Tabulated function's value at each coordinate
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE       :: x              !! X coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE       :: y              !! Y coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE       :: z              !! Z coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE       :: t              !! T coordinate tabulated values
+    REAL(kind=8), DIMENSION(:,:,:,:), ALLOCATABLE :: data           !! Tabulated function's value at each coordinate
+    CHARACTER(len=NF90_MAX_NAME)                  :: xname = "X"    !! Name of the X coordinate
+    CHARACTER(len=NF90_MAX_NAME)                  :: yname = "Y"    !! Name of the Y coordinate
+    CHARACTER(len=NF90_MAX_NAME)                  :: zname = "Z"    !! Name of the Z coordinate
+    CHARACTER(len=NF90_MAX_NAME)                  :: tname = "T"    !! Name of the T coordinate
+    CHARACTER(len=NF90_MAX_NAME)                  :: dname = "data" !! Name of the data block
   END TYPE DSET4D
 
   TYPE, PUBLIC :: DSET5D
     !! A 5D data set
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE         :: x    !! X coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE         :: y    !! Y coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE         :: z    !! Z coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE         :: t    !! T coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:), ALLOCATABLE         :: w    !! W coordinate tabulated values
-    REAL(kind=wp), DIMENSION(:,:,:,:,:), ALLOCATABLE :: data !! Tabulated function's value at each coordinate
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE         :: x              !! X coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE         :: y              !! Y coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE         :: z              !! Z coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE         :: t              !! T coordinate tabulated values
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE         :: w              !! W coordinate tabulated values
+    REAL(kind=8), DIMENSION(:,:,:,:,:), ALLOCATABLE :: data           !! Tabulated function's value at each coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: xname = "X"    !! Name of the X coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: yname = "Y"    !! Name of the Y coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: zname = "Z"    !! Name of the Z coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: tname = "T"    !! Name of the T coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: wname = "W"    !! Name of the W coordinate
+    CHARACTER(len=NF90_MAX_NAME)                    :: dname = "data" !! Name of the data block
   END TYPE DSET5D
 
@@ -165,8 +178,8 @@
   FUNCTION is_in_1d(set,x) RESULT(ret)
     !! Check if point is in the 1D data set
-    TYPE(DSET1D), INTENT(in)  :: set !! Dataset object to search in
-    REAL(kind=wp), INTENT(in) :: x   !! coordinate of the point to check
+    TYPE(DSET1D), INTENT(in) :: set !! Dataset object to search in
+    REAL(kind=8), INTENT(in) :: x   !! coordinate of the point to check
     LOGICAL :: ret                   !! .true. if the point is in the data set, .false. otherwise
-    REAL(kind=wp) :: l,u
+    REAL(kind=8) :: l,u
     ret=.true.
     l  = set%x(1) ; u= set%x(size(set%x))
@@ -177,9 +190,9 @@
   FUNCTION is_in_2d(set,x,y) RESULT(ret)
     !! Check if point is in the 2D data set
-    TYPE(DSET2D), INTENT(in)  :: set !! Dataset object to search in
-    REAL(kind=wp), INTENT(in) :: x   !! X coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: y   !! Y coordinate of the point to check
+    TYPE(DSET2D), INTENT(in) :: set !! Dataset object to search in
+    REAL(kind=8), INTENT(in) :: x   !! X coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: y   !! Y coordinate of the point to check
     LOGICAL :: ret                   !! .true. if the point is in the data set, .false. otherwise
-    REAL(kind=wp) :: l,u
+    REAL(kind=8) :: l,u
     ret=.false.
     l  = set%x(1) ; u= set%x(size(set%x))
@@ -194,10 +207,10 @@
   FUNCTION is_in_3d(set,x,y,z) RESULT(ret)
     !! Check if point is in the 3D data set
-    TYPE(DSET3D), INTENT(in)  :: set !! Dataset object to search in
-    REAL(kind=wp), INTENT(in) :: x   !! X coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: y   !! Y coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: z   !! Z coordinate of the point to check
+    TYPE(DSET3D), INTENT(in) :: set !! Dataset object to search in
+    REAL(kind=8), INTENT(in) :: x   !! X coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: y   !! Y coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: z   !! Z coordinate of the point to check
     LOGICAL :: ret                   !! .true. if the point is in the data set, .false. otherwise
-    REAL(kind=wp) :: l,u
+    REAL(kind=8) :: l,u
     ret=.false.
     l  = set%x(1) ; u= set%x(size(set%x))
@@ -213,11 +226,11 @@
   FUNCTION is_in_4d(set,x,y,z,t) RESULT(ret)
     !! Check if point is in the 4D data set
-    TYPE(DSET4D), INTENT(in)  :: set !! Dataset object to search in
-    REAL(kind=wp), INTENT(in) :: x   !! X coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: y   !! Y coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: z   !! Z coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: t   !! T coordinate of the point to check
+    TYPE(DSET4D), INTENT(in) :: set !! Dataset object to search in
+    REAL(kind=8), INTENT(in) :: x   !! X coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: y   !! Y coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: z   !! Z coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: t   !! T coordinate of the point to check
     LOGICAL :: ret                   !! .true. if the point is in the data set, .false. otherwise
-    REAL(kind=wp) :: l,u
+    REAL(kind=8) :: l,u
     ret=.false.
     l  = set%x(1) ; u= set%x(size(set%x))
@@ -235,12 +248,12 @@
   FUNCTION is_in_5d(set,x,y,z,t,w) RESULT(ret)
     !! Check if point is in the 4D data set
-    TYPE(DSET5D), INTENT(in)  :: set !! Dataset object to search in
-    REAL(kind=wp), INTENT(in) :: x   !! X coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: y   !! Y coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: z   !! Z coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: t   !! T coordinate of the point to check
-    REAL(kind=wp), INTENT(in) :: w   !! W coordinate of the point to check
+    TYPE(DSET5D), INTENT(in) :: set !! Dataset object to search in
+    REAL(kind=8), INTENT(in) :: x   !! X coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: y   !! Y coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: z   !! Z coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: t   !! T coordinate of the point to check
+    REAL(kind=8), INTENT(in) :: w   !! W coordinate of the point to check
     LOGICAL :: ret                   !! .true. if the point is in the data set, .false. otherwise
-    REAL(kind=wp) :: l,u
+    REAL(kind=8) :: l,u
     ret=.false.
     l  = set%x(1) ; u= set%x(size(set%x))
@@ -300,52 +313,78 @@
   END FUNCTION ascii_header
 
-#if HAVE_NC_FTN
-  FUNCTION nc_get_dim(fid,did,var,values,ds) RESULT(ret)
-    !! Get dimensions information of a NetCDF variable 
+  FUNCTION nc_get_dim_by_name(fid,dn,values,ds,did) RESULT(ret)
+    !! Get informations about a dimension.
     !!
     !! The method gets the values and size of a given dimension.
-    INTEGER, INTENT(in)                                   :: fid
+    !!
+    !! Errors occur if:
+    !!
+    !! - the given name is not a dimension name.
+    !! - the size of the dimension is less than 2 (the method assumes dimension has an afferent variable with values).
+    !! - the method can not retrieve the values of the afferent variable.
+    INTEGER, INTENT(in)                                  :: fid
       !! Id of the NetCDF file
-    INTEGER, INTENT(in)                                   :: did
+    CHARACTER(len=NF90_MAX_NAME), INTENT(in)             :: dn
+      !! Name of the dimension.
+    REAL(kind=8), INTENT(out), DIMENSION(:), ALLOCATABLE :: values
+      !! Values of the dimension
+    INTEGER, INTENT(out)                                 :: ds 
+      !! Size of __values__
+    INTEGER, INTENT(out)                                 :: did
       !! Id of the NetCDF dimension 
-    CHARACTER(len=*), INTENT(in)                          :: var
-      !! Name of the related NetCDF variable
-    REAL(kind=wp), INTENT(out), DIMENSION(:), ALLOCATABLE :: values
-      !! Values of the dimension
-    INTEGER, INTENT(out)                                  :: ds 
-      !! Size of __values__
     LOGICAL :: ret
       !! .true. if no error(s) occured, .false. otherwise
     INTEGER                      :: vid,err
-    CHARACTER(len=NF90_MAX_NAME) :: dn
     CHARACTER(len=15)            :: i2s
     ret = .false.
     ! --- Get dimension informations
-    IF (NF90_INQUIRE_DIMENSION(fid,did,dn,ds) /= NF90_NOERR) THEN
-      IF (debug) THEN
-        WRITE(i2s,*) did ; i2s=TRIM(i2s)
-        WRITE(*,'(a)') "ERROR:"//TRIM(var)//": Cannot find "// &
-                 "dimension #"//TRIM(i2s)//" name"
-      ENDIF
-      err = NF90_CLOSE(fid) ; RETURN
-    ENDIF
-    IF (ds < 2) THEN
-      IF (debug) WRITE(*,'(a)') "ERROR:"//TRIM(dn)//": Invalid dimension "// &
-                 "size (<2)"
-      err = NF90_CLOSE(fid) ; RETURN
-    ENDIF
-    IF (NF90_INQ_VARID(fid,TRIM(dn),vid) /= NF90_NOERR) THEN
-      IF (debug) WRITE(*,'(a)') "ERROR:"//TRIM(dn)//": Cannot get ID"
-      err = NF90_CLOSE(fid) ; RETURN
-    ENDIF
+    err = NF90_INQ_DIMID(fid,dn,did)
+    IF (err /= NF90_NOERR) RETURN
+    err = NF90_INQUIRE_DIMENSION(fid,did,len=ds)
+    IF (err /= NF90_NOERR) RETURN
+    IF (ds < 2) RETURN
+    err = NF90_INQ_VARID(fid,TRIM(dn),vid)
+    IF (err /= NF90_NOERR) RETURN
     ALLOCATE(values(ds))
-    IF (NF90_GET_VAR(fid,vid,values) /= NF90_NOERR) THEN
-      IF (debug) WRITE(*,'(a)') "ERROR:"//TRIM(dn)//": Cannot get values"
-      err = NF90_CLOSE(fid) ; RETURN
-    ENDIF
-    ret = .true.
-  END FUNCTION nc_get_dim
-
-  FUNCTION get_nc3_info(path,variable,ncid,vid,dimids) RESULT(ret)
+    err = NF90_GET_VAR(fid,vid,values)
+    IF (err /= NF90_NOERR) RETURN
+    ret = .true.
+  END FUNCTION nc_get_dim_by_name
+
+  FUNCTION nc_get_dim_by_id(fid,did,values,ds,dn) RESULT(ret)
+    !! Get informations about a dimension.
+    !!
+    !! The method gets the values and size of a given dimension.
+    !!
+    !! Errors occur if:
+    !!
+    !! - the given id is not a dimension identifier.
+    !! - the size of the dimension is less than 2 (the method assumes dimension has an afferent variable with values).
+    !! - the method can not retrieve the values of the afferent variable.
+    INTEGER, INTENT(in)                                  :: fid
+      !! Id of the NetCDF file
+    INTEGER, INTENT(in)                                  :: did
+      !! Id of the NetCDF dimension 
+    REAL(kind=8), INTENT(out), DIMENSION(:), ALLOCATABLE :: values
+      !! Values of the dimension
+    INTEGER, INTENT(out)                                 :: ds 
+      !! Size of __values__
+    CHARACTER(len=NF90_MAX_NAME), INTENT(out)            :: dn
+      !! Name of the dimension.
+    LOGICAL :: ret
+      !! .true. if no error(s) occured, .false. otherwise
+    INTEGER                      :: vid,err
+    CHARACTER(len=15)            :: i2s
+    ret = .false.
+    ! --- Get dimension informations
+    IF (NF90_INQUIRE_DIMENSION(fid,did,dn,ds) /= NF90_NOERR) RETURN
+    IF (ds < 2) RETURN
+    IF (NF90_INQ_VARID(fid,TRIM(dn),vid) /= NF90_NOERR) RETURN
+    ALLOCATE(values(ds))
+    IF (NF90_GET_VAR(fid,vid,values) /= NF90_NOERR) RETURN
+    ret = .true.
+  END FUNCTION nc_get_dim_by_id
+
+  FUNCTION get_nc3_info(path,variable,ncid,vid,dimids,verbose) RESULT(ret)
     !! Get variable informations from NetCDF file
     !! 
@@ -358,6 +397,6 @@
     !! - variable's dimensions sizes
     !!
-    !! If no error occured (i.e. the function has returned .true.) then the
-    !! NetCDF file remains open. In other case, the file is closed.
+    !! The method always opens and closes the file. If the file cannot be opened,
+    !! __ncid__ is set to -1.
     CHARACTER(len=*), INTENT(in)                    :: path
       !! Path of the NetCDF file
@@ -370,11 +409,16 @@
     INTEGER, INTENT(out), DIMENSION(:), ALLOCATABLE :: dimids
       !! Id of the variable's dimensions. __dimids__ is not allocated on error.
+    LOGICAL, INTENT(in), OPTIONAL                   :: verbose
+      !! True to print out message on error (default to False).
     LOGICAL :: ret
       !! .true. if no errors occured, .false. otherwise
     INTEGER :: fid,ty,nc,err
-    ret = .false.
+    LOGICAL :: zlog
+    zlog = .false. ; IF (PRESENT(verbose)) zlog = verbose
+    ret = .false.
+    ncid = -1
     ! Opens file
     IF (NF90_OPEN(TRIM(path),NF90_NOWRITE,fid) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'ERROR: Cannot open '//trim(path)
+      IF (zlog) WRITE(*,'(a)') 'ERROR: Cannot open '//trim(path)
       RETURN
     ENDIF
@@ -382,5 +426,5 @@
     ! Searches for variable
     IF (NF90_INQ_VARID(ncid,TRIM(variable),vid) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot find '//TRIM(variable)//' in '//trim(path)
+      IF (zlog) WRITE(*,'(a)') 'Cannot find '//TRIM(variable)//' in '//trim(path)
       nc = NF90_CLOSE(fid)
       RETURN
@@ -389,5 +433,5 @@
     ! 1st call to get type and number of dimensions)
     IF (NF90_INQUIRE_VARIABLE(ncid,vid,xtype=ty,ndims=nc) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
+      IF (zlog) WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
       nc = NF90_CLOSE(fid)
       RETURN
@@ -395,5 +439,5 @@
       ! Checks type
       IF (ty == NF90_CHAR) THEN
-        WRITE(*,'(a)') 'Inconsistent variable type (should be numeric)'
+        IF (zlog) WRITE(*,'(a)') 'Inconsistent variable type (should be numeric)'
         nc = NF90_CLOSE(fid)
         RETURN
@@ -404,14 +448,15 @@
     ! first get dimensions id
     IF (NF90_INQUIRE_VARIABLE(ncid,vid,dimids=dimids) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
+      IF (zlog) WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
       nc = NF90_CLOSE(fid)
       DEALLOCATE(dimids)
       RETURN
     ENDIF
+    nc = NF90_CLOSE(fid)
     ret = .true. 
   END FUNCTION get_nc3_info
 
 #if HAVE_NC4_FTN 
-  FUNCTION get_nc4_info(path,variable,group,ncid,vid,dimids) RESULT(ret)
+  FUNCTION get_nc4_info(path,variable,group,ncid,vid,dimids,verbose) RESULT(ret)
     !! Get variable informations from NetCDF4 file
     !!
@@ -424,6 +469,6 @@
     !! - variable's dimensions sizes
     !!
-    !! If no error occured (i.e. the function has returned .true.) then the
-    !! NetCDF file remains open. In other case, the file is closed.
+    !! The method always opens and closes the file. If the file cannot be opened,
+    !! __ncid__ is set to -1.
     CHARACTER(len=*), INTENT(in)                    :: path
       !! Path of the NetCDF file
@@ -438,11 +483,16 @@
     INTEGER, INTENT(out), DIMENSION(:), ALLOCATABLE :: dimids
       !! Id of the variable's dimensions. On error, __dimids__ is not allocated. 
+    LOGICAL, INTENT(in), OPTIONAL                   :: verbose
+      !! True to print out message on error (default to False).
     LOGICAL :: ret
       !! .true. if no errors occured, .false. otherwise
     INTEGER :: fid,ty,nc,err
-    ret = .false.
+    LOGICAL :: zlog
+    zlog = .false. ; IF (PRESENT(verbose)) zlog = verbose
+    ret = .false.
+    ncid = -1
     ! Opens file
     IF (NF90_OPEN(TRIM(path),NF90_NOWRITE,fid) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'ERROR: Cannot open '//trim(path)
+      IF (zlog) WRITE(*,'(a)') 'ERROR: Cannot open '//trim(path)
       RETURN
     ENDIF
@@ -456,16 +506,16 @@
       ! NF90_ENOGRP is missing from Netcdf-Fortran4.2 : its value=-125
       CASE(-125)
-        WRITE(*,'(a)') TRIM(group)//' does not exist in '//TRIM(path)
+        IF (zlog) WRITE(*,'(a)') TRIM(group)//' does not exist in '//TRIM(path)
         nc = NF90_CLOSE(fid) ; RETURN
       CASE(NF90_ENOTNC4,NF90_ESTRICTNC3)
-        WRITE(*,'(a)') TRIM(path)//' is not a NetCDF-4 file with "group" feature'
+        IF (zlog) WRITE(*,'(a)') TRIM(path)//' is not a NetCDF-4 file with "group" feature'
         nc = NF90_CLOSE(fid) ; RETURN
       CASE(NF90_EHDFERR)
-        WRITE(*,'(a)') "Too bad, an HDF5 error has been reported..."
+        IF (zlog) WRITE(*,'(a)') "Too bad, an HDF5 error has been reported..."
         nc = NF90_CLOSE(fid) ; RETURN
     END SELECT
     ! Searches for variable
     IF (NF90_INQ_VARID(ncid,TRIM(variable),vid) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot find '//TRIM(variable)//' in '//trim(path)
+      IF (zlog) WRITE(*,'(a)') 'Cannot find '//TRIM(variable)//' in '//trim(path)
       nc = NF90_CLOSE(fid)
       RETURN
@@ -474,5 +524,5 @@
     ! 1st call to get type and number of dimensions)
     IF (NF90_INQUIRE_VARIABLE(ncid,vid,xtype=ty,ndims=nc) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
+      IF (zlog) WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
       nc = NF90_CLOSE(fid)
       RETURN
@@ -480,5 +530,5 @@
       ! Checks type
       IF (ty == NF90_CHAR) THEN
-        WRITE(*,'(a)') 'Inconsistent variable type (should be numeric)'
+        IF (zlog) WRITE(*,'(a)') 'Inconsistent variable type (should be numeric)'
         nc = NF90_CLOSE(fid)
         RETURN
@@ -489,20 +539,17 @@
     ! first get dimensions id
     IF (NF90_INQUIRE_VARIABLE(ncid,vid,dimids=dimids) /= NF90_NOERR) THEN
-      WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
+      IF (zlog) WRITE(*,'(a)') 'Cannot access to '//TRIM(variable)//' informations'
       nc = NF90_CLOSE(fid)
       DEALLOCATE(dimids)
       RETURN
     ENDIF
+    nc = NF90_CLOSE(fid)
     ret = .true. 
   END FUNCTION get_nc4_info
 #endif
-#endif
 
   !-------------------------
   ! NetCDF data file readers
   !-------------------------
-
-#if HAVE_NC_FTN
-
 
   FUNCTION ncdf_rd_1d(path,variable,set) RESULT(ret)
@@ -512,5 +559,5 @@
     TYPE(DSET1D), INTENT(out)    :: set      !! Output dataset object
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=NF90_MAX_NAME)       :: dn
@@ -521,4 +568,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,variable,fi,vi,di)) RETURN
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -533,6 +581,6 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -543,4 +591,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -553,5 +602,5 @@
     TYPE(DSET2D), INTENT(out)    :: set      !! Output dataset object
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -561,4 +610,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -573,10 +623,10 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -587,4 +637,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -597,5 +648,5 @@
     TYPE(DSET3D), INTENT(out)    :: set      !! Output dataset object
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -605,4 +656,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -617,14 +669,14 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -635,4 +687,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -645,5 +698,5 @@
     TYPE(DSET4D), INTENT(out)    :: set      !! Output dataset object
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -653,4 +706,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -665,18 +719,18 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ T coordinate
-    IF (.NOT.nc_get_dim(fi,di(4),variable,set%t,ds(4))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(4),set%t,ds(4),set%tname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -687,4 +741,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -697,5 +752,5 @@
     TYPE(DSET5D), INTENT(out)    :: set      !! Output dataset object
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -705,4 +760,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,variable,fi,vi,di)) RETURN
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -717,22 +773,22 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ T coordinate
-    IF (.NOT.nc_get_dim(fi,di(4),variable,set%t,ds(4))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(4),set%t,ds(4),set%tname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ W coordinate
-    IF (.NOT.nc_get_dim(fi,di(5),variable,set%w,ds(5))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(5),set%w,ds(5),set%wname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
